unit hiDiskPathNameExtEX02;

interface

uses Kol,Share,Debug;

type
  THIDiskPathNameExtEX02 = class(TDebug)
   private
     Disk:string;
     Path:string;
     Disk_Path:string;
     Name:string;
     Ext:string;
     Path_Name:string;
     Disk_Path_Name:string;
     Name_Ext:string;
     Path_Name_ext:string;
     Disk_Path_Name_Ext:string;
   public
    _prop_FileName : string;

    _data_FileName : THI_Event;
    _event_onDisk : THI_Event;
    _event_onPath : THI_Event;
    _event_onDisk_Path : THI_Event;
    _event_onName:THI_Event;
    _event_onExt : THI_Event;
    _event_onPath_Name : THI_Event;
    _event_onDisk_Path_Name : THI_Event;
    _event_onName_Ext : THI_Event;
    _event_onPath_Name_ext : THI_Event;
    _event_onDisk_Path_Name_ext : THI_Event;
    
    
    procedure _work_doPart(var _Data:TData; Index:word);
    procedure _var_Disk(var _Data:TData; Index:word);
    procedure _var_Path(var _Data:TData; Index:word);
    procedure _var_Disk_Path(var _Data:TData; Index:word);
    procedure _var_Name(var _Data:TData; Index:word);
    procedure _var_Ext(var _Data:TData; Index:word);
    procedure _var_Path_Name(var _Data:TData; Index:word);
    procedure _var_Disk_Path_Name(var _Data:TData; Index:word);
    procedure _var_Name_Ext(var _Data:TData; Index:word);
    procedure _var_Path_Name_ext(var _Data:TData; Index:word);
    procedure _var_Disk_Path_Name_Ext(var _Data:TData; Index:word);
    
     Function uGetDPNE(DPNEComplette:AnsiString;DPNEDif:ShortString):AnsiString; 
  end;

implementation

procedure THIDiskPathNameExtEX02._work_doPart;
var s:string;
begin
   s := ReadString(_Data,_data_FileName,'');
   if s = '' then exit;

    Disk := (uGetDPNE(s,'disk'));
    Path := (uGetDPNE(s,'path'));
    Disk_Path := (uGetDPNE(s,'disk_path'));
    Name := (uGetDPNE(s,'name'));
    Ext := (uGetDPNE(s,'ext'));
    Path_Name := (uGetDPNE(s,'path_name'));
    Disk_Path_Name := (uGetDPNE(s,'disk_path_name'));
    Name_Ext := (uGetDPNE(s,'name_ext'));
    Path_Name_ext := (uGetDPNE(s,'path_name_ext'));    
    Disk_Path_Name_ext := (uGetDPNE(s,'disk_path_name_ext'));
        
  _hi_OnEvent(_event_onDisk,uGetDPNE(s,'disk'));
  _hi_OnEvent(_event_onPath,uGetDPNE(s,'path'));
  _hi_OnEvent(_event_onDisk_Path,uGetDPNE(s,'disk_path'));
  _hi_OnEvent(_event_onName,uGetDPNE(s,'name'));
  _hi_OnEvent(_event_onExt,uGetDPNE(s,'ext'));
  _hi_OnEvent(_event_onPath_Name,uGetDPNE(s,'path_name'));
  _hi_OnEvent(_event_onDisk_Path_Name,uGetDPNE(s,'disk_path_name'));
  _hi_OnEvent(_event_onName_Ext,uGetDPNE(s,'name_ext'));
  _hi_OnEvent(_event_onPath_Name_ext,uGetDPNE(s,'path_name_ext'));
  _hi_OnEvent(_event_onDisk_Path_Name_ext,uGetDPNE(s,'disk_path_name_ext'));
  
end;

procedure THIDiskPathNameExtEX02._var_Disk(var _Data:TData; Index:word);
begin
   dtString(_Data,Disk);
end;

procedure THIDiskPathNameExtEX02._var_Path(var _Data:TData; Index:word);
begin
   dtString(_Data,Path);
end;

procedure THIDiskPathNameExtEX02._var_Disk_Path(var _Data:TData; Index:word);
begin
   dtString(_Data,Disk_Path);
end;

procedure THIDiskPathNameExtEX02._var_Name(var _Data:TData; Index:word);
begin
   dtString(_Data,Name);
end;

procedure THIDiskPathNameExtEX02._var_Ext(var _Data:TData; Index:word);
begin
   dtString(_Data,Ext);
end;

procedure THIDiskPathNameExtEX02._var_Path_Name(var _Data:TData; Index:word);
begin
   dtString(_Data,Path_Name);
end;

procedure THIDiskPathNameExtEX02._var_Disk_Path_Name(var _Data:TData; Index:word);
begin
   dtString(_Data,Disk_Path_Name);
end;

procedure THIDiskPathNameExtEX02._var_Name_Ext(var _Data:TData; Index:word);
begin
   dtString(_Data,Name_Ext);
end;

procedure THIDiskPathNameExtEX02._var_Path_Name_ext(var _Data:TData; Index:word);
begin
   dtString(_Data,Path_Name_ext);
end;

procedure THIDiskPathNameExtEX02._var_Disk_Path_Name_ext(var _Data:TData; Index:word);
begin
   dtString(_Data,Disk_Path_Name_ext);
end;

Function THIDiskPathNameExtEX02.uGetDPNE(DPNEComplette:AnsiString;DPNEDif:ShortString):AnsiString;
var dl,n:LongInt;
    Mas:array [0..3] of AnsiString;
    uk,First:Byte;
    SExt:AnsiString;
    dif:AnsiString;
begin
try
  dl:=Length(DPNEComplette);
  for uk:=0 to 3 do mas[uk]:='';

  if (DPNEComplette[1]='"')and(DPNEComplette[dl]='"')
  then begin
    First:=2;
    dec(dl);
  end
  else First:=1;

  uk:=3;
  for n:=dl downto First do
  begin
    if uk=0 then mas[0]:=DPNEComplette[n]+mas[0];

    if uk=1
    then begin
      if DPNEComplette[n]<>':' then mas[1]:=DPNEComplette[n]+mas[1]
      else dec(Uk);
    end;

    if uk=2
    then begin
      if DPNEComplette[n]<>'\' then Mas[2]:=DPNEComplette[n]+mas[2]
      else dec(uk);
    end;

    if uk=3
    then begin
      if DPNEComplette[n]=':'
      then begin
        mas[1]:=mas[3];
        mas[3]:='';
        dec(uk);Dec(uk);Dec(Uk);
      end
      else if DPNEComplette[n]='\'
      then begin
        mas[2]:=mas[3];
        mas[3]:='';
        dec(uk);dec(uk);
      end
      else if DPNEComplette[n]<>'.' then Mas[3]:=DPNEComplette[n]+mas[3]
           else dec(uk);
    end;
  end;
  if mas[3]='' then SExt:=''
    else SExt:='.'+mas[3];

  dif:=AnsiLowerCase(DPNEDif);
  if (dif='d')or(Dif='disk') then Result:=mas[0]
  else if (dif='p')or(Dif='path') then Result:=mas[1]
  else if (dif='dp')or(Dif='disk_path') then Result:=mas[0]+':'+mas[1]
  else if (dif='n')or(Dif='name') then Result:=mas[2]
  else if (dif='e')or(Dif='ext') then Result:=mas[3]
  else if (dif='pn')or(Dif='path_name') then Result:=mas[1]+'\'+mas[2]
  else if (dif='dpn')or(Dif='disk_path_name') then Result:=mas[0]+':'+mas[1]+'\'+mas[2]
  else if (dif='ne')or(Dif='name_ext') then Result:=mas[2]+SExt
  else if (dif='pne')or(Dif='path_name_ext') then Result:=mas[1]+'\'+mas[2]+SExt
  else if (dif='dpne')or(Dif='disk_path_name_ext') then Result:=mas[0]+':'+mas[1]+'\'+mas[2]+SExt;
except
  Result:='';
 end;
end;

end.
